> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ulm.m1amdocs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a runtime using the ULM runtimeId

> Changes information for the Connect runtime specified by the runtimeId number. The runtime is updated according to details in the request body. The updated runtime entity is returned in the response.



## OpenAPI

````yaml /portal/Amdocs_Media-ULM-Released-resolved.yaml put /runtime/{runtimeId}
openapi: 3.0.1
info:
  title: Connect APIs
  description: >-
    The Connect/ULM APIs enables clients to manage all aspects against Connect's
    data entities that they are permitted to manage. The data entities supported
    include: (1) USER - a unique individual, (2) RUNTIME - endpoint to which
    services are delivered (e.g. mobile tablet, browser), (3) GROUP - a
    collection of user entities, (4) ACCOUNT - relationship between a USER and
    service provider, (5) SUBSCRIPTION - package of entitlements to a specific
    service, and (6) FEATURE - fine-grained entitlement that defines what a user
    can do for a particular service.


    The APIs offer endpoints for users to onboard, authenticate and manage their
    profile. Please review our OIDC APIs that can be accessed through an active
    web session within the application (i.e. any JavaScript running on the
    server itself) or through authorizing a client application through OIDC or
    OAuth 2.0.


    The majority of these APIs require a user context (session cookie or access
    token) to access their functionality.


    All of the APIs can be accessed via a organization specific domain that was
    provided to you during onboarding.
  version: Draft-GO
servers:
  - url: https://nxt-ulm-pdt.m1amdocs.io/platform/rest/v85
security:
  - cookieAuth: []
  - OIDC: []
tags:
  - name: Account
    description: ULM Account APIs enable standard CRUD operations on ULM account entities.
  - name: Authentication
    description: >-
      Connect authentication APIs open and close user sessions (user login and
      logout).
  - name: Group and Soft Profile
    description: >-
      Connect Group and Soft Profile APIs enable clients to perform group
      management and soft profile functions. A group is a collection of one or
      more Connect entities, typically a user entity. For example, a group can
      be a household that contains 4 users all within the same family. A Soft
      Profile User is a user that can be a minor user or guest user, and they
      are not required to sign up or subscribe to a service. For example, a Soft
      Profile User can be a minor that does not have an email and therefore can
      only access the services if the parent is first authenticated.
  - name: Process
    description: >-
      Connect Process APIs initiate process steps. Connect's library of
      processes include for example Onboarding with Email and Password. These
      processes are intended to provided an preset user journey that your UI can
      follow in steps. 


      A step can be an inital step, one of many subsequent steps, or a final
      step. Some processes may only require one step from start to end.
  - name: Runtime
    description: >-
      Connect Runtimes APIs enables retrieval of Devices that are used by Users
      to interact with ULM.
  - name: Subscription
    description: >-
      Connect Subscription APIs enable standard CRUD operations on a
      subscription entity.
  - name: User
    description: Connect User APIs enable standard CRUD operations on a user entity.
paths:
  /runtime/{runtimeId}:
    put:
      tags:
        - Runtime
      summary: Update a runtime using the ULM runtimeId
      description: >-
        Changes information for the Connect runtime specified by the runtimeId
        number. The runtime is updated according to details in the request body.
        The updated runtime entity is returned in the response.
      operationId: updateRuntimeByRuntimeIdUsingPUT
      parameters:
        - name: runtimeId
          in: path
          description: |-
            The unique ULM ID number of the runtime
            Example: 909
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            format: int64
          example: 1
      requestBody:
        description: >-
          The data transfer object that contains all possible runtime properties
          to be updated
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RuntimePutRequestDto'
        required: false
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RuntimeResponseDto'
        '401':
          description: Authentication Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Generic401Dto'
        '403':
          description: Authtorization Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Generic403Dto'
        '404':
          description: Resource not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RuntimeResponse404'
components:
  schemas:
    RuntimePutRequestDto:
      title: RuntimeDto
      type: object
      properties:
        displayName:
          type: string
          description: The display name
          example: Entity display name
        version:
          type: string
          description: The runtime’s version
          example: 4.1.1
        attributes:
          $ref: '#/components/schemas/RuntimeAttributesPutRequestDto'
      description: RuntimeDto Model
    RuntimeResponseDto:
      title: Runtime
      type: object
      properties:
        activatedDate:
          type: integer
          description: The entity’s activation date and time, expressed in UNIX Epoch time
          format: int64
          example: 1514766808000
        attributes:
          $ref: '#/components/schemas/RuntimeAttributeResponseDto'
        buildType:
          type: string
          description: >-
            The customer-defined build type of this specific runtime. This can
            be used to discriminate between known beta versus production
            hardware.
          example: Production
        createdDate:
          type: integer
          description: The entity’s creation date and time in UNIX Epoch time
          format: int64
          example: 1538682581776
        deactivatedDate:
          type: integer
          description: >-
            The entity’s deactivation date and time, expressed in UNIX Epoch
            time
          format: int64
          example: 1543833950000
        deviceType:
          type: string
          description: The runtime’s type of physical device
          example: phone
        displayName:
          type: string
          description: The display name of the entity
          example: Paul's iPad
        guid:
          type: string
          description: ' The global unique identifier of the runtime provided at login. If this is not provided by the customer, ULM will assign one for tracking purposes.'
          example: DEF123
        id:
          $ref: '#/components/schemas/EntityId'
        platformType:
          type: string
          description: The runtime’s platform type
          example: android
        status:
          $ref: '#/components/schemas/EntityStatus'
        suspendedDate:
          type: integer
          description: The entity’s suspension date and time, expressed in UNIX Epoch time
          format: int64
          example: 1527917430000
        type:
          $ref: '#/components/schemas/EntityType'
        updatedDate:
          type: integer
          description: >-
            The most recent date and time that the entity was updated, expressed
            in UNIX Epoch time
          format: int64
          example: 1538682581776
        userAgent:
          type: string
          description: The runtime’s browser and operating system information
          example: >-
            Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML,
            like Gecko) Chrome/71.0.3578.98 Safari/537.36
        version:
          type: string
          description: The runtime’s version
          example: 4.1.1
      description: >-
        The data model that contains the possible runtime properties. Some
        properties come on a ULM entity by default. Service providers can create
        and add their own additional properties in order to extend the ULM
        platform.
    Generic401Dto:
      type: object
      properties:
        operationError:
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/OperationErrorDto'
        stackTrace:
          type: string
          description: Optional, returned only in debug mode.
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/Generic401DtoOperationErrors'
      description: General Payload for Authentication Error.
    Generic403Dto:
      type: object
      properties:
        operationError:
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/OperationErrorDto'
        stackTrace:
          type: string
          description: Optional, returned only in debug mode.
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/Generic403DtoOperationErrors'
      description: General Payload for Authorization Error.
    RuntimeResponse404:
      type: object
      properties:
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/RuntimeResponse404OperationErrors'
    RuntimeAttributesPutRequestDto:
      type: object
      properties:
        macAddress:
          type: string
          description: The MacAddress
        externalDeviceGUID:
          type: string
          description: External device GUID
    RuntimeAttributeResponseDto:
      type: object
      properties:
        macAddress:
          type: string
          description: Mac address
          example: 000000000001A0
        externalDeviceGUID:
          type: string
          description: External device guid
      description: Runtime Response Attributes
    EntityId:
      type: integer
      description: The unique ID of an entity.
      format: int64
      example: 1
    EntityStatus:
      type: string
      description: >-
        The status of the entity. Possible values include:

        * activating - The entity has been provisioned, but is not yet ready to
        be used or consumed.

        * activated - The entity is active, and the functionality to which it is
        tied is enabled.

        * suspended - The entity is temporarily deactivated, but can be
        reactivated in the future.

        * deactivated - The entity is permanently deactivated, and may be
        deleted from the system in the near future.

        * pending - The entity has been added but is not yet verified for use. 
        It may be linked to an existing entity in order to eventually replace
        the original entity.

        * unknown - This is a generic, catch all state for specific entities.


        Note: This  field is the current status in GET calls, and the desired
        status in PUT and POST calls.
      example: activated
      enum:
        - activating
        - activated
        - suspended
        - deactivated
        - pending
        - unknown
    EntityType:
      type: string
      description: A particular type of a given entity.
      example: com.uxpsystems.ulm.entity.RegularEntityType
    OperationErrorDto:
      title: OperationErrorDto
      required:
        - code
      type: object
      properties:
        code:
          type: string
          description: The business error code
        message:
          type: string
          description: The message that describes the error
          example: Bad user input
        type:
          type: string
          description: >-
            The exception class that caused the error, returned only in debug
            mode.
          deprecated: true
        authorities:
          type: array
          description: Returned only in debug mode.
          items:
            type: string
      description: The data model that contains the Operation Error response details.
    Generic401DtoOperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - authentication-required
        message:
          type: string
          example: Full Authentication Required
    Generic403DtoOperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - ACCESS_FORBIDDEN
            - security-challenge-failed
        message:
          type: string
          example: Access Denied
    RuntimeResponse404OperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - restClientRuntime-not-found
        message:
          type: string
          example: >-
            Information for the following resource was not found:
            com.uxpsystems.mint.framework.device.model.RestClientRuntime[id:909]
  securitySchemes:
    cookieAuth:
      type: apiKey
      name: JSESSIONID
      in: cookie
    OIDC:
      type: oauth2
      description: OAuth 2.0 Authentication
      flows:
        implicit:
          authorizationUrl: /oidc/authorize
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            offline_access: Requests that a refresh token be issued.
            entitlements: Enables the "entitlements" claim.
        password:
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            entitlements: Enables the "entitlements" claim.
        clientCredentials:
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            entitlements: Enables the "entitlements" claim.
        authorizationCode:
          authorizationUrl: /oidc/authorize
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            offline_access: Requests that a refresh token be issued.
            entitlements: Enables the "entitlements" claim.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.